/*
 * led_modes.c
 *
 * Created: 05.05.2016 23:25:26
 *  Author: Hannes
 */ 
#include "includes/light_ws2812.h"
#include "includes/config.h"
#include <util/delay.h>
#include <stdlib.h>

#define PWM_MAX 255
#define PWM_HALF PWM_MAX/2
//#define TABLE_PWM_MAX 100
//#define BASE 10
#define RESOLUTION 50  //number of steps to increment the brightness value


//struct cRGB COLORS[14]; //can be deleted if direct initialization works
struct cRGB LED_COLOR[1];
struct cRGB LED_COLOR_old[1];// = {0}; //stores old color
struct cRGB LED_COLOR_new[1];// = {0}; //stores new color

struct cRGB TEMP[1];
struct cRGB COLORS[14];

uint8_t colorindex = 1;
int16_t step = -1 ;
int16_t brightness_index_red	= 0;
int16_t brightness_index_green	= 0;
int16_t brightness_index_blue	= 0;
int16_t brightness_step_red		= 0;
int16_t brightness_step_green	= 0;
int16_t brightness_step_blue	= 0;

int16_t pwm_difference_red		= 0;
int16_t pwm_difference_green	= 0;
int16_t pwm_difference_blue		= 0;

uint8_t brightnesstable [101]={
0,0,0,0,0,0,1,1,1,1,2,
2,2,3,3,4,5,5,6,7,7,
8,9,10,11,12,13,14,15,17,18,
19,21,22,24,25,27,29,30,32,34,
36,38,40,42,44,46,48,51,53,55,
58,60,63,66,68,71,74,77,80,83,
86,89,92,96,99,102,106,109,113,116,
120,124,128,131,135,139,143,148,152,156,
160,165,169,174,178,183,188,192,197,202,
207,212,217,223,228,233,238,244,249,255
};
/*
COLORS[0].r=0;			COLORS[0].g=0;			COLORS[0].b=0; // black/dark
COLORS[1].r=PWM_MAX;	COLORS[1].g=0;			COLORS[1].b=0; // red
COLORS[2].r=PWM_MAX;	COLORS[2].g=1+PWM_MAX/2;	COLORS[2].b=0; // orange
COLORS[3].r=PWM_MAX;	COLORS[3].g=PWM_MAX;	COLORS[3].b=0; // yellow
COLORS[4].r=1+PWM_MAX/2;	COLORS[4].g=PWM_MAX;	COLORS[4].b=0; // green-yellow
COLORS[5].r=0;			COLORS[5].g=PWM_MAX;	COLORS[5].b=0; // green
COLORS[6].r=0;			COLORS[6].g=PWM_MAX;	COLORS[6].b=1+PWM_MAX/2; // mint-green
COLORS[7].r=0;			COLORS[7].g=PWM_MAX;	COLORS[7].b=PWM_MAX; // turquois
COLORS[8].r=0;			COLORS[8].g=1+PWM_MAX/2;	COLORS[8].b=PWM_MAX; // light blue
COLORS[9].r=0;			COLORS[9].g=0;			COLORS[9].b=PWM_MAX; // blue
COLORS[10].r=1+PWM_MAX/2;COLORS[10].g=0;	COLORS[10].b=PWM_MAX; // violet
COLORS[11].r=PWM_MAX;	COLORS[11].g=0;			COLORS[11].b=PWM_MAX; // pink
COLORS[12].r=PWM_MAX;	COLORS[12].g=0;			COLORS[12].b=1+PWM_MAX/2; // magenta
COLORS[13].r=PWM_MAX;	COLORS[13].g=PWM_MAX;	COLORS[13].b=PWM_MAX; // white*/

/*struct cRGB COLORS[14]={
{0			, 0			, 0		},	// black/dark
{PWM_MAX	, 0			, 0		},	// red
{PWM_MAX	, PWM_HALF	, 0		},	// orange
{PWM_MAX	, PWM_MAX	, 0		},	// yellow
{PWM_HALF	, PWM_MAX	, 0		},	// green-yellow
{0			, PWM_MAX	, 0		},	// green
{0			, PWM_MAX	, PWM_HALF},// mint-green
{0			, PWM_MAX	, PWM_MAX},	// turquois
{0			, PWM_HALF	, PWM_MAX},	// light blue
{0			, 0			, PWM_MAX},	// blue
{PWM_HALF	, 0			, PWM_MAX},	// violet
{PWM_MAX	, 0			, PWM_MAX},	// pink
{PWM_MAX	, 0			, PWM_HALF},// magenta
{PWM_MAX	, PWM_MAX	, PWM_MAX}	// white											
};*/

void LED_EVENT(uint8_t i){
	
	TEMP[0]= COLORS[i];
	ws2812_setleds(TEMP,1);	
	_delay_ms(500);
	TEMP[0]= COLORS[0];
	ws2812_setleds(TEMP,1);	
	_delay_ms(500);	
}

void initColors(void){ //>>> can be deleted if direct initialization works <<<
	COLORS[0].r=0;			COLORS[0].g=0;			COLORS[0].b=0; // black/dark
	COLORS[1].r=PWM_MAX;	COLORS[1].g=0;			COLORS[1].b=0; // red
	COLORS[2].r=PWM_MAX;	COLORS[2].g=1+PWM_MAX/2;	COLORS[2].b=0; // orange
	COLORS[3].r=PWM_MAX;	COLORS[3].g=PWM_MAX;	COLORS[3].b=0; // yellow
	COLORS[4].r=1+PWM_MAX/2;	COLORS[4].g=PWM_MAX;	COLORS[4].b=0; // green-yellow
	COLORS[5].r=0;			COLORS[5].g=PWM_MAX;	COLORS[5].b=0; // green
	COLORS[6].r=0;			COLORS[6].g=PWM_MAX;	COLORS[6].b=1+PWM_MAX/2; // mint-green
	COLORS[7].r=0;			COLORS[7].g=PWM_MAX;	COLORS[7].b=PWM_MAX; // turquois
	COLORS[8].r=0;			COLORS[8].g=1+PWM_MAX/2;	COLORS[8].b=PWM_MAX; // light blue
	COLORS[9].r=0;			COLORS[9].g=0;			COLORS[9].b=PWM_MAX; // blue
	COLORS[10].r=1+PWM_MAX/2;COLORS[10].g=0;	COLORS[10].b=PWM_MAX; // violet
	COLORS[11].r=PWM_MAX;	COLORS[11].g=0;			COLORS[11].b=PWM_MAX; // pink
	COLORS[12].r=PWM_MAX;	COLORS[12].g=0;			COLORS[12].b=1+PWM_MAX/2; // magenta
	COLORS[13].r=PWM_MAX;	COLORS[13].g=PWM_MAX;	COLORS[13].b=PWM_MAX; // white
}

struct cRGB stroboscope(void){
	
	brightness_step_red = 1;
	
	if( brightness_index_red == 0 )brightness_index_red = 100;
	
	LED_COLOR[0].r = brightnesstable[brightness_index_red];
	LED_COLOR[0].g = brightnesstable[brightness_index_red];
	LED_COLOR[0].b = brightnesstable[brightness_index_red];
	
	brightness_index_red -= brightness_step_red;
	
	return LED_COLOR[0];	
}

struct cRGB colorFade(void){	
	//uint8_t random_color_value;
	
	//if ( brightness_step_red ==0 && brightness_step_green ==0 & brightness_step_blue ==0)LED_EVENT(7);
	
	if(LED_COLOR[0].r != LED_COLOR_new[0].r)	  
		LED_COLOR[0].r = brightnesstable[brightness_index_red]; // as long as final value isn't reached for each color
		
	else if(LED_COLOR[0].g != LED_COLOR_new[0].g) 
		LED_COLOR[0].g = brightnesstable[brightness_index_green];
		
	else if(LED_COLOR[0].b != LED_COLOR_new[0].b) 
		LED_COLOR[0].b = brightnesstable[brightness_index_blue];
		
	else{
		LED_COLOR_old[0].r = LED_COLOR[0].r;
		LED_COLOR_old[0].g = LED_COLOR[0].g;
		LED_COLOR_old[0].b = LED_COLOR[0].b;
	
		if (colorindex ==12)colorindex =1;
		LED_COLOR_new[0] = COLORS[colorindex];
		colorindex += 1;
		//LED_EVENT(9);
		//LED_EVENT(colorindex);

	
	//srand(2);
	//random_color_value = rand() % 13 +1; // generate random value between 1 and 12 (including 12) 
	//LED_COLOR_new[0].r = Colors(random_color_value).r;
	//LED_COLOR_new[0].g = Colors(random_color_value).g;
	//LED_COLOR_new[0].b = Colors(random_color_value).b;
	}
	
	//float brightness_step_red		= 0.0;
	//float brightness_step_green		= 0.0;
	//float brightness_step_blue		= 0.0;		
	
	pwm_difference_red		= pwmDifference(LED_COLOR_old[0].r,LED_COLOR_new[0].r); // Either 0, 127.5 or 255
	pwm_difference_green	= pwmDifference(LED_COLOR_old[0].g,LED_COLOR_new[0].g); // Either 0, 127.5 or 255
	pwm_difference_blue		= pwmDifference(LED_COLOR_old[0].b,LED_COLOR_new[0].b); // Either 0, 127.5 or 255
		
	brightness_step_red		= brighnessStep(pwm_difference_red); // Speed is 0 for same, 1/2 for 127 and 1 for 255 as difference each in positive or negative direction.
	brightness_step_green	= brighnessStep(pwm_difference_green); // Speed is 0 for same, 1/2 for 127 and 1 for 255 as difference each in positive or negative direction.
	brightness_step_blue	= brighnessStep(pwm_difference_blue); // Speed is 0 for same, 1/2 for 127 and 1 for 255 as difference each in positive or negative direction.
	
	brightness_index_red	+= brightness_step_red;
	brightness_index_green	+= brightness_step_green;
	brightness_index_blue	+= brightness_step_blue;
	
	return LED_COLOR_old[0];
}

struct cRGB colorStatic(uint8_t index){
	return COLORS[index];
}

struct cRGB colorPulse(uint8_t index){
		
	if( (LED_COLOR_old[0].r != COLORS[index].r) || (LED_COLOR_old[0].g != COLORS[index].g) || (LED_COLOR_old[0].b != COLORS[index].b) ){
		
		LED_COLOR_old[0] = COLORS[index]; // assign actual color to old color
		pwm_difference_red		= pwmDifference(LED_COLOR_old[0].r,0); // Either 0, 127.5 or 255
		pwm_difference_green	= pwmDifference(LED_COLOR_old[0].g,0); // Either 0, 127.5 or 255
		pwm_difference_blue		= pwmDifference(LED_COLOR_old[0].b,0); // Either 0, 127.5 or 255
		
		brightness_step_red		= brighnessStep(pwm_difference_red); // Speed is 0 for same, 1/2 for 127 and 1 for 255 as difference each in positive or negative direction.
		brightness_step_green	= brighnessStep(pwm_difference_green); // Speed is 0 for same, 1/2 for 127 and 1 for 255 as difference each in positive or negative direction.
		brightness_step_blue	= brighnessStep(pwm_difference_blue); // Speed is 0 for same, 1/2 for 127 and 1 for 255 as difference each in positive or negative direction.
		
		brightness_index_red = 0; brightness_index_green = 0; brightness_index_blue = 0; 
		
		LED_COLOR[0] = COLORS[0]; // switch off Color		
		step = -1;
	}
	
	if( (brightness_index_red == 100 || brightness_index_green == 100 || brightness_index_blue == 100) || 
		(brightness_index_red == 0 && brightness_index_green == 0 && brightness_index_blue == 0) )
		step = -step; // toggle step 1 or -1
	
	brightness_index_red	+= step * brightness_step_red;
	brightness_index_green	+= step * brightness_step_green;
	brightness_index_blue	+= step * brightness_step_blue;
	
	LED_COLOR[0].r = brightnesstable[brightness_index_red];
	LED_COLOR[0].g = brightnesstable[brightness_index_green];
	LED_COLOR[0].b = brightnesstable[brightness_index_blue];

	return LED_COLOR[0];
}

int16_t pwmDifference(uint8_t pwm_Value_New, uint8_t pwm_Value_Old){
	return pwm_Value_New - pwm_Value_Old;
}
int8_t brighnessStep (uint8_t pwm_Difference){
	if(pwm_Difference == -127) return -1; //special case of 128-255=-127 -->function would return 0 instead of -1
	else return  ((100*pwm_Difference) / PWM_MAX)/RESOLUTION;
}


	

